//"createRaportOkr.sc","Dodanie paragonw do raportw okresowych","\System\Pomocnicze\",0,1.0.0,SYSTEM
/////////////////////////////////////////////////////////////////////////////////////////
// Autor: Jakub Kryski
// Data utworzenia: 	2021-05-24
// wer. HMF2021.2

#include "Kopiowanie do bufora - include"

NoOutput()

long id, typDKtd, seriaDKtd, subtyp
int nIlosc, i
String sSQL,sCheck, typDK = "", seriaDK = "", msg

dispatch app = GetApplication()
dispatch xConn=GetAdoConnection()
dispatch xRecDK="ADODB.Recordset"
dispatch xRecDK1="ADODB.Recordset"
xRecDK.LockType=1
xRecDK.CursorType=0

if GetDispatchObjectID() != 0x2BA0 then
	Message using "Raport '%s' musi by uruchamiany z okna kartoteki dokumentw sprzeday dla zaznaczonych dokumentw.\nNaley przenie raport do podkatalogu Sprzeda w katalogu 'Kartoteki'.\nWwczas raport bdzie dostpny na licie raportw w wyborze wydrukw." , GetreportName()
	end
EndIf

if !(nIlosc=MakeIdTable()) then Message("Nie wybrano adnego paragonu"): error ""

int err=Message("Zaznaczone paragony zostan dodane do odpowiednich raportw okresowych.\nCzy chcesz kontynuowac?{{icon=! buttons=[&Kontynuuj:o](&Przerwij:a)}}")
if err==2 then
	end
endif

WriteStatusBar(using "Wystawianie paragonw...=%d%%%%,255", 0)

for i=1 to i>nIlosc
	id = tab_id(i)
	if (id) then
		sCheck = Using "SELECT dk.subtyp AS subtyp, kh.kod AS kod, CASE WHEN dk.subtyp = 50 THEN kh.nazwisko ELSE kh.naglowek END typdzial, CASE WHEN dk.subtyp = 50 THEN kh.imie ELSE kh.nip END seriadzial, ISNULL(td.billingPeriodType, 0) AS typraport, ISNULL(td.billingPeriodSerie, 0) AS seriaraport FROM HM.KH kh INNER JOIN HM.DK dk ON dk.magazyn = kh.id INNER JOIN HM.TD td ON td.kod = dk.typ_dk WHERE dk.id = %l", id
		xRecDK.Open(sCheck,xConn)
		subtyp = xRecDK.Fields("subtyp").Value
		if(subtyp == 50 || subtyp == 51) then
			typDKtd = xRecDK.Fields("typraport").Value
			seriaDKtd = xRecDK.Fields("seriaraport").Value
			if(typDKtd == 0 || seriaDKtd == 0) then
				typDK = xRecDK.Fields("typdzial").Value
				seriaDK = xRecDK.Fields("seriadzial").Value
			else
				typDK = "TAK"
				seriaDK = "TAK"
			endif

			if(typDK  == "" || seriaDK  == "") then 
				msg = ""
				if (typDK  == "") then
					if (subtyp == 50) then msg += "Brak wypenionego pola 'raport okresowy' dla dziau "+xRecDK.Fields("kod").Value+".\n"		
					if (subtyp == 51) then msg += "Brak wypenionego pola 'raport okresowy dla korekt' dla dziau "+xRecDK.Fields("kod").Value+".\n"
				endif
				if (seriaDK  == "") then
					if (subtyp == 50) then msg += "Brak wypenionego pola 'seria' raportu okresowego dla dziau "+xRecDK.Fields("kod").Value+".\n"		
					if (subtyp == 51) then msg += "Brak wypenionego pola 'seria' raportu okresowego dla korekt dla dziau "+xRecDK.Fields("kod").Value+".\n"
				endif
				Message(msg)
				error ""
			else //zeby nie zmieniac procedur robimy tutaj wszystko wyslane jednym zapytaniem
				sSQL = Using "DECLARE @IdPeriodicSaleReport INT; DECLARE @id INT = %l; SELECT @IdPeriodicSaleReport = IdPeriodicSaleReport FROM HM.DK WHERE id = @id; IF (@IdPeriodicSaleReport = NULL) BEGIN  	EXEC HM.IsDocumentAsPeriodicSaleReport @id; END ELSE BEGIN 	UPDATE HM.DK SET IdPeriodicSaleReport = NULL WHERE id = @id; 	IF ((SELECT COUNT(id) FROM hm.DK WHERE IdPeriodicSaleReport = @IdPeriodicSaleReport) = 0) 		DELETE FROM hm.PeriodicSaleReports WHERE Id = @IdPeriodicSaleReport; 	ELSE 		EXEC Hm.RecalculatePeriodicSaleReport NULL, @IdPeriodicSaleReport; 	EXEC HM.IsDocumentAsPeriodicSaleReport @id; END", id	
				xRecDK1.Open(sSQL,xConn)		 
			endif
		endif
		xRecDK.Close()
	endif
	WriteStatusBar(using "Wystawianie paragonw ...=%d%%%%,255", (i*100/)nIlosc)
next i

WriteStatusBar("Zakoczono")

Message "Paragony zostay dodane do raportw okresowych."

Error ""