//"ekspRO.sci","Eksport RO - include","\Eksport\Eksport include\",0,2.0.2,SYSTEM
/////////////////////////////////////////
// "Eksport RO - include"
// ekspRO.sci
/////////////////////////////////////////

int DECLARE PrintError(String msg)

int Sub EksportRapOkr(long idRapOkr, int iNieEkspOznak, int iRownoKsiegMag, int iDekretyZbiorcze)
	Dispatch xRapOkr=xRapOkrMan.Give(using "id=%l",idRapOkr)
	Dispatch xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", xRapOkr.typDok)	//xRapOkr.TypDk)

	if !xTypDokumentuSp then PrintError("Brak BTypDokumentuSp")

	Dispatch xDokSp = xFactory.NewObject("BDokSp")
	Dispatch xKartParamsDokSp = xFactory.NewObject("BKartParamsDokSp")

	Dispatch xDokumentSp = xFactory.NewObject("BDokumentSp")

	rozUidStrona = 0
	int err, nRes, ii, jj, iPom, iPomStVat
	float wartosc
	String strOkres
	EksportRapOkr = 1

	Dispatch xDekretacjeRapOkr = xFactory.NewObject("BDekretacjeRapRO")
	Dispatch xDekretParamsRapOkr

	xDekretacjeRapOkr.Clear()
	xDekretParamsRapOkr = xDekretacjeRapOkr.Params()
	xDekretParamsPn.id=xRapOkr.id
	xDekretParamsPn.RownolegleMAG = (iRownoKsiegMag)
	xDekretParamsPn.czyZbiorcze = (iDekretyZbiorcze)
	xDekretParamsPn.czyEkspOznak = !(iNieEkspOznak)
	if(xDekretacjeRapOkr.Dekret(xDekretParamsPn) != 0) then
		eksport.AddError("Nie mona wyeksportowa dokumentu " + xRapOkr.numerDokumentu + ". Dekretacja nie powioda si.")
		EksportRapOkr = 0
		exit
	endif
	
	if (iDekretyZbiorcze!=0) then
		xDekretacjeRapOkr.OptymalizujMg()
	endif	

	eksport.PoczatekSekcji("Dokument", idRapOkr)
		eksport.Pole("rodzaj_dok", "sprzeday")
		eksport.Pole("JPK_V7", "RO")
		eksport.Pole("symbol FK", xTypDokumentuSp.symbolFK)
		eksport.Pole("obsluguj jak", xTypDokumentuSp.TypFK)

		eksport.Pole("kod", xRapOkr.numerDokumentu)
		eksport.Pole("opis FK",	xDekretacjeRapOkr.trescwFK)
		eksport.Pole("dataWystawienia", xRapOkr.dataOd)
		eksport.Pole("dataSprzedazy", xRapOkr.dataOd)
		eksport.Pole("kwota", (Using "%.2f", xRapOkr.wartoscBrutto))
		eksport.Pole("Sygnatura", xFactory.uzytkownik.kod)

		//////////////////////////////////////////////////////
		// numer dokumentu w FK
		eksport.Pole("FK nazwa", xRapOkr.numerDokumentu)

		//na potrzeby MKP
		eksport.Pole( "od_brutto", "1" )
		eksport.Pole( "typ_dk", xRapOkr.typDok )
		eksport.Pole( "seria", xRapOkr.seria )
		eksport.Pole( "serianr", ( Using "%l", xRapOkr.numerSeryjny ) )
		eksport.Pole( "okres", ( Using "%l", xRapOkr.okresRaportowania ) )
		eksport.Pole( "dzial", ( Using "%l", xRapOkr.dzial ) )

		xKartParamsDokSp.raportOkresowyId = xRapOkr.Id
		nRes = xDokSp.Load(xKartParamsDokSp)

		//////////// eksport kontrahentw z paragonw ////////////////////
		ii=1
		Dispatch xKh
		Dispatch xDk
		while !nRes && ii <= xDokSp.Count()
			xDk = xDokSp.item(ii)

			if len(xDk.kodKontrahenta) != 0 then
				xKh = GetObjByKod("BKh", xDk.kodKontrahenta)

				if xKh then
					EksportKH(xKh.id, 0)
				endif
			endif
			ii=ii+1
		wend
		//////////// eksport kontrahentw z paragonw ////////////////////

		//zapisy
		WriteStatusBar(using "Eksport zapisw dokumentu: %s", xRapOkr.numerDokumentu)
		ZapiszZAP(xDekretacjeRapOkr, 0, 0, "", 0, 0, TiRapOkr)
		
		//rozrachunki
		WriteStatusBar(using "Eksport rozrachunkw dokumentu: %s", xRapOkr.numerDokumentu)
		ZapiszTRAROZ(xDekretacjeRapOkr, 1, 0)

		//rejestry vat
		//		
		Dispatch dpRejestr
		Dispatch dpStVat
		Dispatch pozycja	
		Dispatch xDokumentZbiorczyPar
		InfoTabRejVat TabRejVatParZbior
		int iPercentage

		ii=1
		while !nRes && ii <= xDokSp.Count()
			xDokumentZbiorczyPar=GetObjById("BDokumentSp",xDokSp.item(ii).Id)
			
			iPercentage = (ii * 100) / xDokSp.Count()
			WriteStatusBar(using "Generowanie rejestru VAT dla dokumentu: %s (%s)\t\t%l%%%%=%l%%%%,255", xRapOkr.numerDokumentu, xDokumentZbiorczyPar.kod, iPercentage, iPercentage)

				for jj=1 to jj>(xDokumentZbiorczyPar.Pozycje.Count())
					if (xDokumentZbiorczyPar.CzyKorekta) then
						wartosc = 0
						if (xDokumentZbiorczyPar.Pozycje.item(jj).idpozkoryg) then
							pozycja = xDokumentZbiorczyPar.Pozycje.item(jj).przedKorekta
							dpRejestr = pozycja.rejestrVAT
							dpStVat = pozycja.stVAT
							TabRejVatParZbior.Wstaw(dpRejestr, dpStVat, pozycja,1,0,1,1)
							wartosc = -(pozycja.niePodlega + pozycja.netto)
												
							pozycja = xDokumentZbiorczyPar.Pozycje.item(jj).poKorekcie
							dpRejestr = pozycja.rejestrVAT
							dpStVat = pozycja.stVAT
							TabRejVatParZbior.Wstaw(dpRejestr, dpStVat, pozycja,1,0,0,1)
							wartosc = wartosc + (pozycja.niePodlega + pozycja.netto)
						endif
					else
						pozycja = xDokumentZbiorczyPar.Pozycje.item(jj)
						dpRejestr = pozycja.rejestrVAT
						dpStVat = pozycja.stVAT
						TabRejVatParZbior.Wstaw(dpRejestr, dpStVat, pozycja,1,0,0,1)
						
					endif
				next jj
			ii=ii+1
		wend

		WriteStatusBar("")

				for iPom=1 to iPom>TabRejVatParZbior.IloscRejestrow(0)
					for iPomStVat=1 to iPomStVat>TabRejVatParZbior.IloscStawek(iPom)
						if (TabRejVatParZbior.RejVat(iPom).Skrot!="") then
							eksport.PoczatekPodsekcji("Rejestr")
								// ABC
								eksport.Pole("Skrot", TabRejVatParZbior.RejVat(iPom).Skrot)
								eksport.Pole("Nazwa", TabRejVatParZbior.RejVat(iPom).Nazwa)
								eksport.Pole("Rodzaj", (using "%d",TabRejVatParZbior.RejVat(iPom).rodzaj))
								eksport.Pole("JPK_V7", AggregatedGTU())
								eksport.Pole("ABC", "1")
							
								eksport.Pole("metoda_VAT", iif(xDokumentZbiorczyPar.metodaVAT,"1","0"))
					
								// okres
								eksport.Pole("datarej", xDokumentZbiorczyPar.dataRejestrVAT)	//dla maej ksigowoci
								buf =xDokumentZbiorczyPar.dataRejestrVAT
								strOkres = Find Regular "????????" // osiem pierwszych znakw
	
								eksport.Pole("okres", (strOkres + "01"))
								eksport.Pole("stawka", (Using "%.2f", TabRejVatParZbior.Wartosc(iPom, iPomStVat, "stawka")))
	
								eksport.Pole("brutto", (Using "%.2f", Round( (TabRejVatParZbior.Wartosc(iPom, iPomStVat, "netto") + TabRejVatParZbior.Wartosc(iPom, iPomStVat, "vat")),2 )))
								eksport.Pole("netto", (Using "%.2f", Round( TabRejVatParZbior.Wartosc(iPom, iPomStVat, "netto"),2 )))
								eksport.Pole("vat", (Using "%.2f", Round( TabRejVatParZbior.Wartosc(iPom, iPomStVat, "vat"),2 )))
								//eksport.Pole("sumanetto", (Using "%.2f", Round( TabRejVatParZbior.RejVat(iPom).SumNetto,2 )))
								//eksport.Pole("sumavat", (Using "%.2f", Round( TabRejVatParZbior.RejVat(iPom).SumVat,2 )))
							
								
							eksport.KoniecSekcji() //"Rejestr"
						endif
					next iPomStVat
				next iPom

				TabRejVatParZbior.IloscRejestrow(-1)
				TabRejVatParZbior.ClearRec()

	eksport.KoniecSekcji() //"Dokument"
EndSub